from tkinter import *
from tkinter import messagebox
import tkinter.simpledialog as sim
import math
#------------(ユーザ指定用関数)------------------------------
def inpAsk(setType,title="都市座標設定方法",#■都市座標設定方法入力
           message= "[Cancel]:終了, 0:乱数，1:整列"):
    tmp="aaa"
    while tmp!=None and tmp!="0" and tmp!="1":
        tmp=sim.askstring(title, message,initialvalue=str(setType))
    return tmp

def inpNumCity(NX,NY):#■都市数の入力
    while True:
        STRV="%d, %d"%(NX,NY)
        tmp=sim.askstring("都市の数入力",
                          "[Cancel]:終了，都市数を入力して下さい。",
                          initialvalue=STRV)
        if tmp==None: return None
        S1=""; ID=0;N=len(tmp)
        for i in range(N): 
            if tmp[i]=="*" or tmp[i]==",": ID=i+1; break
            S1+=tmp[i]
        S2=""
        if ID!=0:
            for i in range(ID,N): S2+=tmp[i]
        if S2=="":S2="1"
        try: # 整数書式エラーのとき再度入力
            n1=int(S1);n2=int(S2);n=n1*n2
            if n>=4: return [n1,n2]
            else: messagebox.showerror("エラー","都市数は4以上")
        except: messagebox.showerror("エラー","整数書式エラー")

#------------(描画用関数)------------------------------
def scale(X):return X*20+30#■画面座標系
def drawState(canvas, text):
    canvas.create_text(275,10,text=text,tag="DT", font=('Times',8))
def drawCity(canvas, cityXY,C1="#FFFF77",C2="red",width=2 ):#■経路表示
    N=len(cityXY);NN=N-1
    for i in range(N):#経路の表示
        X1=scale(cityXY[i][0]);Y1=scale(cityXY[i][1]);i2=i+1
        if i==NN: i2=0
        X2=scale(cityXY[i2][0]);Y2=scale(cityXY[i2][1])
        canvas.create_line(X1, Y1, X2, Y2, fill=C2, tag="DT", width=width)
    for i in range(N):#都市位置の表示
        X=scale(cityXY[i][0]);Y=scale(cityXY[i][1])
        canvas.create_oval(X-8, Y-8, X+8, Y+8, fill=C1, tag="DT")
def drawPno(canvas,XX):#■都市番号表示
    N=len(XX)
    for i in range(N):
        X=scale(XX[i][0]);Y=scale(XX[i][1]);S="%d"%(XX[i][2])
        canvas.create_text(X, Y, text=S, tag="DT",
                           font=('Times',6,"bold"))
def drawCityData(canvas, XX,cityXY,drawNoFlag=True):#■都市描画
    canvas.delete("DT");drawCity(canvas,XX)
    if drawNoFlag: drawPno(canvas,XX)
    drawCity(canvas,cityXY,C1="white",C2="black",width=1)
    if drawNoFlag: drawPno(canvas,cityXY)
def drawCityOnly(canvas, XX,drawNoFlag=True):#■ルート登録のみ描画
    canvas.delete("DT"); drawCity(canvas,XX)
    if drawNoFlag: drawPno(canvas,XX)
def draw2Point(canvas, Xi,Xj):#■2点の表示
    X1=scale(Xi[0]);Y1=scale(Xi[1])
    X2=scale(Xj[0]);Y2=scale(Xj[1])
    CL="#CCCCFF";ft=('Times',8,"bold")
    canvas.create_line(X1,Y1,X2,Y2,fill="blue",tag="DT",width=2)
    canvas.create_oval(X1-10,Y1-8,X1+8,Y1+8,fill=CL,tag="DT")
    canvas.create_oval(X2-10,Y2-8,X2+8,Y2+8,fill=CL,tag="DT")
    canvas.create_text(X1,Y1,text=str(Xi[2]), tag="DT",font=ft)
    canvas.create_text(X2,Y2,text=str(Xj[2]), tag="DT",font=ft)
def drawPoint(canvas, Xi):#■2点の表示(線なし)
    X1=scale(Xi[0]);Y1=scale(Xi[1])
    CL="#CCCCFF";ft=('Times',8,"bold")
    canvas.create_oval(X1-8,Y1-8,X1+8,Y1+8,fill=CL,tag="DT")
    canvas.create_text(X1,Y1,text=str(Xi[2]), tag="DT",font=ft)
def print2Move(Xi,Xj,DZ,DM):#■隣接2点移動表示
    if abs(DM-DZ)>0.000001:
        print("隣接2点移動 1(P%d,P%d)"%(Xi[2],Xj[2]))
        print("   ",DZ,"→",DM)
                                
def printExchange(DM,DZ,XX, LL):#■距離短縮表示
    print("1点挿入による距離短縮 %8.4f→%8.4f"%(DZ,DM))
    print("   P%d:(%8.4f,%8.4f)の後にP%d:(%8.4f,%8.4f)を挿入" %
          (XX[2],XX[0],XX[1], LL[2],LL[0],LL[1]))

def printExchange2(DM,DZ,P1,P2,P3,P4):#■距離短縮表示
    print("辺挿入による距離短縮 %8.4f→%8.4f"%(DZ,DM))
    print(" 元(P%d→P%d)   P%d→P%d→P%d→P%d" %
          (P1[2],P2[2],P1[2],P3[2],P4[2],P2[2]))
def printExchange1(DM,DZ,P1,P3,P4):
    print("隣接2点挿入 P%d after P%d, P%d "%(P1[2],P3[2],P4[2]))
    print("    ", DM,DZ)

def strXYP(D):#■点座標書式文字
    No=D[2]; X=D[0];Y=D[1]
    return str("P%d(%8.4f, %8.4f)"%(D[2], D[0],D[1]))
